// BestTimes.cpp: implementation of the BestTimes class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RBRSingleRally.h"
#include "BestTimes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//-----------------------------------------------------------------------------

void BestTimes::Clear ()
{
  times.clear();
}

//-----------------------------------------------------------------------------

bool BestTimes::LoadStageRecords ()
{
  Clear();

  HANDLE hFile = CreateFile("SavedGames\\pfresult.rst",GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
  
  if (hFile==INVALID_HANDLE_VALUE) return false;

  SetFilePointer(hFile,0x0c,0,FILE_BEGIN);

  BestTime bestTime;

  int size = sizeof bestTime;
  char ach[128];
  sprintf(ach,"size=%i",size);

  for (;;)
  {
    DWORD dwRead;
    if (!ReadFile(hFile,&bestTime,sizeof bestTime,&dwRead,0)) break;
    if (dwRead!=sizeof bestTime) break;
    if (!bestTime.map) break;
    bestTime.player[19]=0; 
    times.push_back(bestTime);
  }

  CloseHandle(hFile);
  return true;
}

//-----------------------------------------------------------------------------

const BestTime* BestTimes::Get (int map)
{
  for (int i=0;i<times.size();i++) if (times[i].map==map) return &times[i];
  return 0;
}

//-----------------------------------------------------------------------------

bool BestTimes::UpdateRecord (const BestTime& bestTime)
{
  return false;

  // does not work this way :-((
  // file is ignore by RBR after that modification, probably
  // some checksum in the header

/*

  CString msg;
  bool res=false;

  HANDLE hFile=CreateFile("SavedGames\\pfresult.rst",GENERIC_WRITE|GENERIC_READ,0,0,OPEN_EXISTING,0,0);
  if (hFile==INVALID_HANDLE_VALUE)
  {
    msg.Format("Could not open pfresults (%i)",GetLastError());
    OutputDebugString(msg);
    return false;
  }

  int size=GetFileSize(hFile,0);

  HANDLE hMap=CreateFileMapping(hFile,0,PAGE_READWRITE,0,0,0);
  if (hMap)
  {
    char *pfile = (char*)MapViewOfFile(hMap,FILE_MAP_ALL_ACCESS,0,0,0);
    BestTime *ftimes = (BestTime*)(pfile+0x0c);

    while ((char*)(ftimes+1)-pfile <= size)
    {
      if (ftimes->map==bestTime.map)
      {
        if (ftimes->time > bestTime.time) *ftimes=bestTime,res=true;
        break;
      }
      ftimes++;
    }
    CloseHandle(hMap);
  }
  else
  {
    msg.Format("Could not create file mapping object for pfresults (%i)",GetLastError());
    OutputDebugString(msg);
  }

  CloseHandle(hFile);
  return res;

*/
}

//-----------------------------------------------------------------------------




