// BestTimes.h: interface for the BestTimes class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BESTTIMES_H__B50F5062_2F92_4E8B_8687_8BEC4687E29B__INCLUDED_)
#define AFX_BESTTIMES_H__B50F5062_2F92_4E8B_8687_8BEC4687E29B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
using namespace std;

//-----------------------------------------------------------------------------

struct BestTime 
{
  int map;
  int car;
  float check[2];
  float time;
  char player[32];
};

//-----------------------------------------------------------------------------

class BestTimes  
{

public: // methods

  void Clear ();
  bool LoadStageRecords ();
  const BestTime* Get (int map);
  bool UpdateRecord (const BestTime& bestTime);

private: // data

  vector<BestTime> times;

};

//-----------------------------------------------------------------------------

#endif // !defined(AFX_BESTTIMES_H__B50F5062_2F92_4E8B_8687_8BEC4687E29B__INCLUDED_)
