// Stage.cpp: implementation of the Stage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Stage.h"
#include "PluginHelpers.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//-----------------------------------------------------------------------------

Stage::Stage (int stageIndex,int weatherIndex)
{
  index=stageIndex;
  driven=false;
  check[0]=check[1]=finish=0.;
  const char *pch = GetStageName(index);
  if (!pch) index=71; // use rally school in case of invalid id
  name=GetStageName(index);
  weather=weatherIndex;
  if (weather<0||weather>2) weather=0;

  bestTime=false;
}

//-----------------------------------------------------------------------------

bool Stage::Dnf () const
{
  return driven&&(finish==0.);
}

bool Stage::Valid () const
{
  return driven&&(finish!=0.);
}

//-----------------------------------------------------------------------------

void Stage::Reset ()
{
  driven=false;
  check[0]=check[1]=finish=0.;
}

//-----------------------------------------------------------------------------




