// Stage.h: interface for the Stage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STAGE_H__7D8AC169_A421_4F3A_A436_6B8F26BBD3AC__INCLUDED_)
#define AFX_STAGE_H__7D8AC169_A421_4F3A_A436_6B8F26BBD3AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IRBRGame.h"

//-----------------------------------------------------------------------------

struct StageTime
{
  int index;
  int weather;
  float check[2];
  float finish;
};

struct Stage:public StageTime
{
  CString name;
  bool driven;

  bool bestTime;
  StageTime best;

	Stage (int stageIndex,int weatherIndex=IRBRGame::GOOD_WEATHER);
  bool Dnf () const;
  bool Valid () const;
  void Reset ();

};

//-----------------------------------------------------------------------------

#endif // !defined(AFX_STAGE_H__7D8AC169_A421_4F3A_A436_6B8F26BBD3AC__INCLUDED_)
